package main.java.mg.yra.lib.trackingring;

import android.content.Context;
import android.util.AttributeSet;
import android.widget.ImageView;

/**
 * Created by Yvan on 18/08/15.
 */
public class TrackingRingView extends ImageView {

    private DataSet mDataSet;
    private OverlayedCircularProgressDrawable mDrawable;
    private int startangle = -90;
    private int animationduration = 800;
    private int ringtextcolor = 0xffffffff;

    public TrackingRingView(Context context) {
        super(context);
    }

    public TrackingRingView(Context context, AttributeSet attrs) {
        super(context, attrs);
    }

    public TrackingRingView(Context context, AttributeSet attrs, int defStyleAttr) {
        super(context, attrs, defStyleAttr);
    }

    public DataSet getDataSet() {
        return mDataSet;
    }

    public void setDataSet(DataSet dataSet) {
        mDataSet = dataSet;
        mDrawable = new OverlayedCircularProgressDrawable(mDataSet, 0.325f);
        mDrawable.setStartAngle(startangle);
        mDrawable.setAnimationDuration(animationduration);
        mDrawable.setRingTextColor(ringtextcolor);
        setImageDrawable(mDrawable);
    }

    public void setStartAngle(int sa){
        startangle = sa;
    }

    public void setAnimationDuration(int ad) {
        animationduration = ad;
    }

    public void setRingTextColor(int rtc) {
        ringtextcolor = rtc;
    }

}
