package trackingringwrapper;

import main.java.mg.yra.lib.trackingring.TrackingRingView;
import android.content.Context;
import android.graphics.Bitmap;
import android.graphics.drawable.Drawable;
import android.util.DisplayMetrics;
import android.view.ViewGroup;
import anywheresoftware.b4a.BA;
import anywheresoftware.b4a.BA.Author;
import anywheresoftware.b4a.BA.Hide;
import anywheresoftware.b4a.BA.Pixel;
import anywheresoftware.b4a.BA.ShortName;
import anywheresoftware.b4a.BA.Version;
import anywheresoftware.b4a.BALayout;
import anywheresoftware.b4a.keywords.Common.DesignerCustomView;
import anywheresoftware.b4a.objects.LabelWrapper;
import anywheresoftware.b4a.objects.PanelWrapper;
import anywheresoftware.b4a.objects.ViewWrapper;
import anywheresoftware.b4a.BA.Events;
import android.view.MotionEvent;

import android.view.View;
import android.view.View.OnClickListener;
import android.view.View.OnLongClickListener;
import android.view.View.OnTouchListener;
import android.view.ViewParent;

import android.graphics.BitmapShader;
import android.graphics.Shader;
import android.graphics.drawable.ShapeDrawable;
import android.graphics.drawable.shapes.RectShape;

import android.app.Activity;
import android.graphics.Color;
import android.os.Bundle;


import main.java.mg.yra.lib.trackingring.DataEntry;
import main.java.mg.yra.lib.trackingring.DataSet;
import main.java.mg.yra.lib.trackingring.OverlayedCircularProgressDrawable;

import java.util.ArrayList;
import java.util.List;



@Author("Johan Schoeman")
@Version(1.00f)
@ShortName("TrackingRingView")
public class trackingRingWrapper extends ViewWrapper<TrackingRingView> implements DesignerCustomView {


	private BA ba;
	private String eventName;
        private TrackingRingView cv;
        private int numberofrings = 3;
        private int[] ringcolors = {Color.BLUE, Color.CYAN, Color.RED};
	private int[] ringbackgroundcolors = {Color.LTGRAY, Color.WHITE, Color.LTGRAY};
        private String[] ringtext = {"A", "B", "C"};
        private int[] ringprogressvalue = {62, 87, 45};
	
	public void Initialize(BA ba, String EventName) {
		_initialize(ba, null, EventName);
	}

	@Hide
	public void _initialize(BA ba, Object activityClass, String EventName) {
		this.eventName = EventName.toLowerCase(BA.cul);
		this.ba = ba;
		cv = new TrackingRingView(ba.context);
                this.setObject(cv);
//                setEventName(this.eventName);
//                addListener();
 	}


//        @Hide
//        public void setEventName(String en){
//            cv.setEventName(en);
//            cv.invalidate(); 
//       }


//    @Hide
//    public void addListener(){
//        cv.setCallback(new PopSeekBarView.Callback() {
//            @Override
//            public void value_changed() {

//              if (ba.subExists(eventName + "_value_changed")) {
//                ba.raiseEvent2(ba, false, eventName + "_value_changed", true, new Object[0]);
//              }
//            }

//            @Override
//            public void started() {

//              if (ba.subExists(eventName + "_started")) {
//                ba.raiseEvent2(ba, false, eventName + "_started", true, new Object[0]);
//              }
//            }


//        });
//    }


	
	//programmatically add view
        @Hide
	public void AddToParent(ViewGroup Parent, @Pixel int left, @Pixel int top, @Pixel int width, @Pixel int height) {
		Parent.addView(cv, new BALayout.LayoutParams(left, top, width, height));
	}
	
	//this method cannot be hidden.
  
        
	public void DesignerCreateView(PanelWrapper base, LabelWrapper lw, anywheresoftware.b4a.objects.collections.Map props) {
		ViewGroup vg = (ViewGroup) base.getObject().getParent();
		AddToParent(vg, base.getLeft(), base.getTop(), base.getWidth(), base.getHeight());
		base.RemoveView();
		//set text properties
	}



	public void setLeft(int left)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.left = left;
		cv.getParent().requestLayout();
	}

	public int getLeft()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.left;
	}
	public void setTop(int top)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.top = top;
		cv.getParent().requestLayout();
	}
 
	public int getTop()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.top;
	}
	
	public void setWidth(int Width)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.width = Width;
		cv.getParent().requestLayout();
	}

	public int getWidth()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.width;
	}
	
	public void setHeight(int height)	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		lp.height = height;
		cv.getParent().requestLayout();
	}

	public int getHeight()	{
		BALayout.LayoutParams lp = (BALayout.LayoutParams)cv.getLayoutParams();
		return lp.height;
	}


    public void ConfigureRings(){
//        configureRingView1();
        configureRingView2();
    }

//    private void configureRingView1() {
//        final List<DataEntry> entries = new ArrayList();
//        entries.add(new DataEntry(35, ba.applicationContext.getResources().getDrawable(android.R.drawable.ic_menu_mapmode), Color.BLUE, Color.LTGRAY));
//        entries.add(new DataEntry(50, ba.applicationContext.getResources().getDrawable(android.R.drawable.ic_menu_camera), Color.MAGENTA, Color.WHITE));
//        entries.add(new DataEntry(60, ba.applicationContext.getResources().getDrawable(android.R.drawable.ic_menu_compass), Color.GREEN, Color.LTGRAY));
//        final DataSet dataset = new DataSet(entries);
//        cv.setDataSet(dataset);
//    }

    private void configureRingView2() {
        final List<DataEntry> entries = new ArrayList<DataEntry>();
        for (int i = 0; i < numberofrings; i++){
           entries.add(new DataEntry(ringprogressvalue[i], ringtext[i], ringcolors[i], ringbackgroundcolors[i]));
        }
//        entries.add(new DataEntry(87, "87", Color.CYAN, Color.WHITE));
//        entries.add(new DataEntry(45, "45", Color.RED, Color.LTGRAY));
        final DataSet dataset = new DataSet(entries);
        cv.setDataSet(dataset);
    }
   

    /**
     * Set the number of rings to draw
    */
    public void setNumberOfRings(int nor){
        numberofrings = nor;
    }
     
    /**
     * Set the ring colors
     * The first element of the array will be the color for the most inner ring
    */
    public void setRingColors(int[] rc){
        ringcolors = rc;
    }

    /**
     * Set the backgroung colors for the rings
     * The first element of the array will be the background color for the most inner ring
    */
    public void setRingBackgroundColors(int[] rbc){
        ringbackgroundcolors = rbc;
    }

    /**
     * Set the text that will appear in the rings
     * The first element of the array will be the text for the most inner ring
    */
    public void setRingText(String[] rt){
        ringtext = rt;
    }

    /**
     * Set the text that will appear in the rings
     * The first element of the array will be the text for the most inner ring
    */
    public void setRingProgressValues(int[] rpv){
        ringprogressvalue = rpv;
    }

    /**
     * Set the start angle of the rings
     * 0 = 3 'o clock position
     * 90 or -270 = 6 'o clock position
     * 180 or -180 = 9 'o clock position
     * 270 or -90 = 12 'o clock position
    */
    public void setStartAngle(int sa){
        cv.setStartAngle(sa);
    }

    /**
     * Set the duration of the animation
    */
    public void setAnimationDuration(int ad) {
        cv.setAnimationDuration(ad);
    }

    /**
     * Set the color of the text inside the rings
    */
    public void setRingTextColor(int rtc) {
        cv.setRingTextColor(rtc);
    }


}
